GhemicalMMReader
Date: 2019-10-22

org.jmol.adapter.readers.simple

## Class GhemicalMMReader

- java.lang.Object
- - org.jmol.adapter.smarter.AtomSetCollectionReader
  - - org.jmol.adapter.readers.simple.GhemicalMMReader

- All Implemented Interfaces:
    javajs.api.GenericLineReader

      public class GhemicalMMReader
      extends AtomSetCollectionReader

  Reads Ghemical ( http://www.uku.fi/~thassine/ghemical) molecular mechanics (*.mm1gp) files. `!Header mm1gp 100 !Info 1 !Atoms 6 0 6 1 6 2 1 3 1 4 1 5 1 !Bonds 5 1 0 D 2 0 S 3 0 S 4 1 S 5 1 S !Coord 0 0.06677 -0.00197151 4.968e-07 1 -0.0667699 0.00197154 -5.19252e-07 2 0.118917 -0.097636 2.03406e-06 3 0.124471 0.0904495 -4.84021e-07 4 -0.118917 0.0976359 -2.04017e-06 5 -0.124471 -0.0904493 5.12591e-07 !Charges 0 -0.2 1 -0.2 2 0.1 3 0.1 4 0.1 5 0.1 !End`
  Author:
    Egon Willighagen

- - ### Field Summary

    - ### Fields inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addedData, addedDataKey, addVibrations, allowPDBFilter, ANGSTROMS_PER_BOHR, applySymmetryToBonds, asc, baseAtomIndex, binaryDoc, bsFilter, bsModels, calculationType, continuing, debugging, desiredModelNumber, desiredSpaceGroupIndex, desiredVibrationNumber, doApplySymmetry, doCentralize, doCheckUnitCell, doConvertToFractional, doPackUnitCell, doProcessLines, doReadMolecularOrbitals, dssr, fileName, fileOffset, filePath, fileScaling, fillRange, filter, filterHetero, fixJavaFloat, forcePacked, getHeader, haveAtomFilter, haveModel, havePartialChargeFilter, htParams, ignoreFileSpaceGroupName, ignoreFileSymmetryOperators, ignoreFileUnitCell, ignoreStructure, iHaveFractionalCoordinates, iHaveSymmetryOperators, iHaveUnitCell, isBinary, isConcatenated, isDSSP1, isFinalized, isMolecular, isPrimitive, isSequential, isTrajectory, latticeCells, latticeScaling, latticeType, line, lstNCS, matUnitCellOrientation, modDim, modelNumber, ms, mustFinalizeModelSet, next, out, packingError, prevline, primitiveToCrystal, ptLine, ptSupercell, reader, readerName, requiresBSFilter, reverseModels, rotateHexCell, sgName, stateScriptVersionInt, strSupercell, symmetry, templateAtomCount, thisBiomolecule, trajectorySteps, unitCellOffset, unitCellParams, useAltNames, useFileModelNumbers, validation, vibrationNumber, vibsFractional, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GhemicalMMReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `checkLine()`
    `(package private) void` | `processAtoms()`
    `(package private) void` | `processBonds()`
    `(package private) void` | `processCharges()`
    `(package private) void` | `processCoord()`
    `(package private) void` | `processHeader()`
    `(package private) void` | `processInfo()`

    - ### Methods inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addAtomXYZSymName, addExplicitLatticeVector, addJmolScript, addSites, addSiteScript, appendLoadNote, appendUunitCellInfo, applySymmetryAndSetTrajectory, applySymTrajASCR, checkCurrentLineForScript, checkFilterKey, checkLastModel, checkLineForScript, clearUnitCell, cloneLastAtomSet, discardLinesUntilBlank, discardLinesUntilContains, discardLinesUntilContains2, discardLinesUntilNonBlank, discardLinesUntilStartsWith, discardPreviousAtoms, doGetModel, doGetVibration, doPreSymmetry, fill3x3, fillDataBlock, fillDataBlockFixed, fillFloatArray, fillFrequencyData, filterAtom, filterReject, finalizeMOData, finalizeModelSet, finalizeReaderASCR, finalizeSubclassReader, finalizeSubclassSymmetry, forceSymmetry, fractionalizeCoordinates, getElementSymbol, getFilter, getFortranFormatLengths, getInterface, getNewSymmetry, getStrings, getSymmetry, getTokens, getTokensFloat, initializeReader, initializeSymmetry, initializeSymmetryOptions, initializeTrajectoryFile, isLastModel, newAtomSet, parseFloat, parseFloatRange, parseFloatStr, parseInt, parseIntAt, parseIntRange, parseIntStr, parseToken, parseTokenNext, parseTokenRange, parseTokenStr, processBinaryDocument, processDOM, rd, read3Vectors, readDataObject, readLines, readNextLine, rejectAtomName, RL, set2D, setAtomCoord, setAtomCoordScaled, setAtomCoordTokens, setAtomCoordXYZ, setChainID, setElementAndIsotope, setFilter, setFilterAtomTypeStr, setFractionalCoordinates, setIsPDB, setLoadNote, setModelPDB, setSpaceGroupName, setSymmetryOperator, setTransform, setUnitCell, setUnitCellItem, setup, setupASCR`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GhemicalMMReader

          public GhemicalMMReader()

  - ### Method Detail

    - #### checkLine

          protected boolean checkLine()
                               throws java.lang.Exception

      Overrides:
        `checkLine` in class `AtomSetCollectionReader`
      Returns:
        true if need to read new line
      Throws:
        `java.lang.Exception`

    - #### processHeader

          void processHeader()

    - #### processInfo

          void processInfo()

    - #### processAtoms

          void processAtoms()
                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### processBonds

          void processBonds()
                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### processCoord

          void processCoord()
                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### processCharges

          void processCharges()
                       throws java.lang.Exception

      Throws:
        `java.lang.Exception`